EDIT - feature request #7957

Add types for taxon description (as EnumSet)
12/17/2018 01:16 PM - Patrick Plitzner

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdm Estimated time: 0:00 hour
Target version: CDM UML 5.8

Severity: normal

Description

When working on the Character Matrix there are 3 types of taxon descriptions:

1. default taxon description
2. taxon descriptions from literature
3. aggregated taxon descriptions

To be able to differentiate between them we need two more marker types for "literature” and "default".
Currently we use:

e MarkerType.COMPUTED() for "aggregated"
¢ MarkerType.IN_BIBLIOGRAPHY() for "literature"
e MarkerType. TO_BE_CHECKED() for "default"

Current usage with hibernate Criterion (see DescriptionDaolmpl):

private void addDescriptionTypesCriterion (Set<DescriptionType> descriptionTypes, Criteria
criteria) {
if (descriptionTypes !'= null && !'descriptionTypes.isEmpty()) {
Set<Criterion> typeCriteria = new HashSet<>();
for (DescriptionType descriptionType : descriptionTypes) {
typeCriteria.add(Restrictions.sglRestriction("{alias}.types like '&"+

descriptionType.getKey () +"$'"));

}

criteria.add(Restrictions.and(typeCriteria.toArray(new Criterion[]{})));

}

Related issues:

Related to EDIT - feature request #8128: Add indicator for feature facts and/... Duplicate
Related to EDIT - task #10109: Investigate best practice for HQL with enumset New
Precedes EDIT - feature request #8471: Computed descriptions should be disabl... Closed
Precedes EDIT - feature request #8472: Transmission engine for distribution a... Closed

Associated revisions

Revision 229e074a - 12/17/2018 01:18 PM - Patrick Plitzner

ref #7957 Change marker to avoid "Uses" details view

Revision 19628913 - 08/16/2019 10:10 AM - Andreas Miiller
fix #7957 add types to DescriptionBase

Revision 9276e073 - 08/16/2019 10:34 AM - Andreas Miiller
ref #7957 add not null to update script for DescriptionBase.types

Revision c34a11ca - 08/16/2019 03:35 PM - Andreas Miiller

ref #7957 adapt tests to DescriptionBase.types not null
Revision 96b27743 - 08/16/2019 08:03 PM - Andreas Miiller
ref #7957 add javadoc to description types

Revision 647d3230 - 10/14/2019 11:06 AM - Patrick Plitzner
ref #7957 Add (web) service for filtering descriptions by type

History

#1 - 12/17/2018 01:17 PM - Patrick Plitzner
- Description updated

#2 - 12/18/2018 01:48 PM - Patrick Plitzner
- Description updated

#3 - 12/18/2018 01:48 PM - Patrick Plitzner
- Description updated

#4 - 08/14/2019 11:44 AM - Patrick Plitzner
- Target version changed from Unassigned CDM tickets to COM UML 5.15

#5 - 08/14/2019 11:45 AM - Patrick Plitzner
- Status changed from New to In Progress

- Priority changed from New to Highest

#6 - 08/15/2019 06:23 PM - Andreas Miiller
- Target version changed from CDM UML 5.15 to CDM UML 5.8

#7 - 08/16/2019 10:38 AM - Andreas Miiller
- Status changed from In Progress to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib[1962891319edeb12380aa69994467{674a96ce96.

#8 - 08/16/2019 12:36 PM - Andreas Miiller
- Precedes feature request #8471: Computed descriptions should be disabled in TaxEditor added

#9 - 08/16/2019 12:38 PM - Andreas Miiller
- Subject changed from Add marker types for taxon description to Add types for taxon description (as EnumSet)

- Assignee changed from Andreas Miiller to Patrick Plitzner

This has been implemented now as an EnumSet for better performance.
Please review.

#10 - 08/16/2019 12:42 PM - Andreas Miiller

- Precedes feature request #8472: Transmission engine for distribution aggregation needs to be adapted to new DescriptionBase.types added

#11 - 08/19/2019 04:15 PM - Patrick Plitzner
- Status changed from Resolved to Closed
- Assignee changed from Patrick Plitzner to Andreas Miiller

- % Done changed from 50 to 100

Adapted descriptive data set service to use DescriptionType. Tried aggregation and tested display in matrix editor. Also checked DB. Seems to work
fine.

#12 - 10/11/2019 01:28 PM - Andreas Miiller

- Related to feature request #8128: Add indicator for feature facts and/or vocabularies which description type they support added
#13 - 10/11/2019 03:11 PM - Patrick Plitzner
- Description updated

#14 - 07/29/2022 08:50 PM - Andreas Miiller
- Related to task #10109: Investigate best practice for HQL with enumset added
